--Written by Ryan Johnson
--Date: 2006-11-10
--http://fluidae.com/

--You make use this code freely.
--Currently runs only on linux and windows.

--Euphoria 3.0.0 or higher required for the idletask() procedure.
--If you have an older version, you can still use nanosleep() if you comment out idletask()


include machine.e
include misc.e
include dll.e

atom syslib, func_sleep, func_usleep
  
   syslib = open_dll("/usr/lib/libc.dylib")
   func_usleep = define_c_func(syslib, "usleep", {C_UINT}, C_INT)
   func_sleep = define_c_func(syslib, "sleep", {C_UINT}, C_INT)



global procedure nanosleep(atom s)
--Sleeps for s seconds. 0.000000001 s = 1 nanosecond.
--This is compatible with the sleep() function. However, you can use non-integers as well.
--For example:
--  nanosleep(0.001) --sleeps for 1 millisecond
--  nanosleep(0.000000001) --this is the smallest amount of time possible (linux)
--  nanosleep(0) --sleeps for the smallest amount of time possible
--  nanosleep(1.5)
--  nanosleep(17.0003) 
--  nanosleep(0.5)
--
--Note: It is normal for the program to sleep for slightly more than the specified time, due
--to multitasking scheduling.
--Also, on windows, the resolution seems to be only milliseconds, not nanoseconds.

   atom void
   atom seconds, microseconds
   seconds = floor(s)
   microseconds = (s - floor(s)) * 1000000
    if  seconds>0 then
	 void = c_func(func_sleep, {seconds })
     end if
    if microseconds>0 then	
     void = c_func(func_usleep, { microseconds })
    end if
end procedure

global procedure idletask(atom idletime)
--allows the new Euphoria task manager to idle the cpu when other tasks are not scheduled to run.
--without this, a Euphoria program will use 100% cpu when there is less than 1 second between
--scheduled tasks!
--
--To use this properly, insert the following code into your program:
--
--   atom task_idle
--   task_idle = task_create(routine_id("idletask"), {0.001})
--   task_schedule(task_idle, 1)
--
--The task will be scheduled to run whenever real-time tasks are not running. It should not
--affect the performance of the application.
--If you want to, you can experiment with different values for idletime.If you try 0 seconds
--on windows, you program may still use 100% CPU.  I would recomment trying 0.001 seconds first.

   while 1 do
      nanosleep(idletime)
      task_yield()
   end while
end procedure
 
