/*****************************************************************************/
/*      (c) Copyright 2006 Rapid Deployment Software - See License.txt       */
/*****************************************************************************/
/*                                                                           */
/*                           CALLS TO C ROUTINES                             */
/*                                                                           */
/*****************************************************************************/

/* DIRTY CODE! Modify this to push values onto the call stack 
 * N.B.!!! stack offset for variables "arg", and "argsize"
 * below must be correct! - make a .asm file to be sure.
 *
 * C Calling Conventions (there are many #define synonyms for these):
 * __cdecl: The caller must pop the arguments off the stack after the call.
 *          (i.e. increment the stack pointer, ESP). This allows a 
 *          variable number of arguments to be passed.
 *          This is the default.
 *
 * __stdcall: The subroutine must pop the arguments off the stack.
 *            It assumes a fixed number of arguments are passed.
 *            The WIN32 API is like this.
 *
 * Both conventions return floating-point results on the top of
 * the hardware floating-point stack, except that Watcom is non-standard 
 * for __cdecl, since it returns a pointer to the floating-point result 
 * in EAX, (although the final result could also be on the top of the
 * f.p. stack just by chance).
 *
 * Watcom restores the stack pointer ESP at the end of call_c() below, 
 * just after making the call to the C routine, so it doesn't matter 
 * if it neglects to increment the stack pointer. This means that
 * Watcom can call __cdecl (of other compilers but not it's own!)
 * and __stdcall routines, using the *same* __stdcall convention.
 */           
 
 
 /* this file modified for OSX by Alban
 In OSX the caller simply lays the variables onto the stack 
 e.g 
 int test(x,y)
 
 
 
 x is at sp
 y is at sp+4
 
 this is not a PUSH
 The arguments need to be reversed from the order in the sequence.
	   
 */

#define I386
#define EBSD
#define ELINUX
#include <stdio.h>
#include "alldefs.h"

/**********************/
/* Imported variables */
/**********************/
extern unsigned char TempBuff[];
extern int c_routine_next;         /* index of next available element */
extern struct arg_info *c_routine; /* array of c_routine structs */

/*******************/
/* Local variables */
/*******************/


#ifdef PPC
int sp (void) { 
	__asm__("mr     r0, r1"); 
}
#endif

object call_c();
void end_of_call_c();
object ztask_create();
void scheduler();
void end_of_scheduler();



int *zsp; // OSX

// removed linux, windows etc..
object call_c(int func, object proc_ad, object arg_list)
/* Call an OSX function in a shared library. 
   Alternatively, call a machine-code routine at a given address. */
{
    
	int buffer[256]; // BEWARE 64 argument limit or 32 doubles may want to increase this
	volatile unsigned long arg;  // !!!! magic var to push values on the stack
    volatile *bptr;
	int argsize;        // !!!! number of bytes to pop 
	int words;
	
    s1_ptr arg_list_ptr, arg_size_ptr;
    object_ptr next_arg_ptr, next_size_ptr;
    object next_arg, next_size;
    int iresult, i;
    double dbl_arg, dresult;
    float flt_arg, fresult;
    unsigned long size;
    int proc_index;
   // int cdecl_call;
    int (*int_proc_address)();
    unsigned return_type;
    char NameBuff[100];

    // Setup and Check for Errors
    
    proc_index = get_pos_int("c_proc/c_func", proc_ad); 
    if ((unsigned)proc_index >= c_routine_next) {
	sprintf( (char*) TempBuff, "c_proc/c_func: bad routine number (%d)",  proc_index);
	RTFatal(TempBuff);
    }
    
    int_proc_address = c_routine[proc_index].address;

    if (IS_ATOM(arg_list)) {
	RTFatal("c_proc/c_func: argument list must be a sequence");
    }
    

    arg_list_ptr = SEQ_PTR(arg_list);
    
 
	
    next_arg_ptr = arg_list_ptr->base + arg_list_ptr->length;
    
    // only look at length of arg size sequence for now
    arg_size_ptr = c_routine[proc_index].arg_size;
    next_size_ptr = arg_size_ptr->base + arg_size_ptr->length;
    
    return_type = c_routine[proc_index].return_size; // will be INT
    
    if (func && return_type == 0 || !func && return_type != 0) {
	if (c_routine[proc_index].name->length < 100)
	    MakeCString(NameBuff, MAKE_SEQ(c_routine[proc_index].name));
	else
	    NameBuff[0] = '\0';
	sprintf((char*) TempBuff, func ? "%s does not return a value" :
				 "%s returns a value",
				 NameBuff);
	RTFatal(TempBuff);
    }
	
    if (arg_list_ptr->length != arg_size_ptr->length) {
	if (c_routine[proc_index].name->length < 100)
	    MakeCString(NameBuff, MAKE_SEQ(c_routine[proc_index].name));
	else
	    NameBuff[0] = '\0';
	sprintf((char*)TempBuff, "C routine %s() needs %d argument%s, not %d",
			  NameBuff,
			  arg_size_ptr->length,
			  (arg_size_ptr->length == 1) ? "" : "s",
			  arg_list_ptr->length);
	RTFatal(TempBuff);
    }
    
    argsize = arg_list_ptr->length << 2;

    words=0;
    
	#ifdef PPC
		zsp = sp();
	#endif
	#ifdef I386
		asm("movl %esp,_zsp  ");	
	#endif


	bptr=&buffer[0];
	for (i = 1; i <= arg_list_ptr->length; i++) {
    
	next_arg = *next_arg_ptr--;
	next_size = *next_size_ptr--;
	
	if (IS_ATOM_INT(next_size))
	    size = INT_VAL(next_size);
	else if (IS_ATOM(next_size))
	    size = (unsigned long)DBL_PTR(next_size)->dbl;
	else 
	    RTFatal("This C routine was defined using an invalid argument type");

	if (size == C_DOUBLE || size == C_FLOAT) {
	    /* push 8-byte double or 4-byte float */
	    if (IS_ATOM_INT(next_arg))
		dbl_arg = (double)next_arg;
	    else if (IS_ATOM(next_arg))
		dbl_arg = DBL_PTR(next_arg)->dbl;
	    else { 
		arg = arg+argsize+9999; // 9999 = 270f hex - just a marker for asm code
		RTFatal("arguments to C routines must be atoms");
	    }

	    if (size == C_DOUBLE) {
		
		arg = *(1+(unsigned long *)&dbl_arg);
		*bptr++ = arg;  // push high-order half last OSX
		argsize += 4;
		arg = *(unsigned long *)&dbl_arg;
		*bptr++ = arg; // don't combine this with the push() below - Lcc bug
		words +=2;
		  
		}
		
	    else {
		/* C_FLOAT */
		flt_arg = (float)dbl_arg;
		arg = *(unsigned long *)&flt_arg;
		*bptr++ = arg;
		words++;
	    }
	}
	else {
	    /* push 4-byte integer */
	    if (size >= E_INTEGER) {
		if (IS_ATOM_INT(next_arg)) {
		    if (size == E_SEQUENCE)
			RTFatal("passing an integer where a sequence is required");
		}
		else {
		    if (IS_SEQUENCE(next_arg)) {
			if (size != E_SEQUENCE && size != E_OBJECT)
			    RTFatal("passing a sequence where an atom is required");
		    }
		    else {
			if (size == E_SEQUENCE)
			    RTFatal("passing an atom where a sequence is required");
		    }
		    RefDS(next_arg);
		}
		arg = next_arg;
		*bptr++ = arg;
		words++;
	    } 
	    else if (IS_ATOM_INT(next_arg)) {
		arg = next_arg;
		*bptr++ = arg;
		words++;
	    }
	    else if (IS_ATOM(next_arg)) {
		// atoms are rounded to integers
		arg = (unsigned long)DBL_PTR(next_arg)->dbl; //correct
		// if it's a -ve f.p. number, Watcom converts it to int and
		// then to unsigned int. This is exactly what we want.
		// Works with the others too.
		*bptr++ = arg;
		words++;
	    }
	    else {
		arg = arg+argsize+9999; // just a marker for asm code
		RTFatal("arguments to C routines must be atoms");
	    }
	}
    }    
	
	
    // reverse arguments...
     
	while ( words > 0 ) 
	{ 
	  *zsp++ =  *(--bptr);
	  words--;
	}
    // clear stack until 16byte boundary 
	 while( ((int)zsp % 16)>0) *zsp++=0;
	
	
    // Make the Call - The C compiler thinks it's a 0-argument call
    
    // might be VOID C routine, but shouldn't crash

    if (return_type == C_DOUBLE) {
	// expect double to be returned from C routine
        
	dresult = (*((double (__stdcall *)())int_proc_address))();

   
	return NewDouble(dresult);
    }
    
    else if (return_type == C_FLOAT) {
	// expect float to be returned from C routine
    
	    fresult = (*((float (__stdcall *)())int_proc_address))();

  
	return NewDouble((double)fresult);
    }
    
    else {
	// expect integer to be returned
     
	    iresult = (*((int (__stdcall *)())int_proc_address))();
  
	if ((return_type & 0x000000FF) == 04) {
	    /* 4-byte integer - usual case */
	    // check if unsigned result is required 
	    if ((return_type & C_TYPE) == 0x02000000) {
		// unsigned integer result
		if ((unsigned)iresult <= (unsigned)MAXINT) {
		    return iresult;
		}
		else
		    return NewDouble((double)(unsigned)iresult);
	    }
	    else {
		// signed integer result
		if (return_type >= E_INTEGER ||
		    (iresult >= MININT && iresult <= MAXINT)) {
		    return iresult;
		}
		else
		    return NewDouble((double)iresult);
	    }
	}
	else if (return_type == 0) {
	    return 0; /* void - procedure */
	}
	/* less common cases */
	else if (return_type == C_UCHAR) {
	    return (unsigned char)iresult;
	}
	else if (return_type == C_CHAR) {
	    return (signed char)iresult;
	}
	else if (return_type == C_USHORT) {
	    return (unsigned short)iresult;
	}
	else if (return_type == C_SHORT) {
	    return (short)iresult;
	}
	else
	    return 0; // unknown function return type
    }
}





